
function tabloc_setting_startup(){
	tabloc_setting_makeSkinList();
	tabloc_setting_makeKeyList("listShiftLockKey");
	tabloc_setting_makeKeyList("listShiftTabLockKey");
	tabloc_setting_load();
	document.getElementById('cbCloseActive').disabled
		= !(document.getElementById('cbPreventClose').checked);
}

function tabloc_setting_accept(){
	tabloc_setting_save();
	return true;
}

/**
 * pref ǂݍŃRg[̒lݒ肷
 */
function tabloc_setting_load(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");

		var prefValue = tabloc_getPrefValue(prefString);

		prefElement[prefAttribute] = prefValue;
		prefElement.setAttribute(prefAttribute, prefValue);
	}
}

/**
 * Rg[̒l pref ɕۑ
 */
function tabloc_setting_save(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");

		var prefValue = prefElement[prefAttribute];
		var prefLastValue = tabloc_getPrefValue(prefString);
		var prefType = typeof(tabloc_getDefaultValue(prefString));

		if(prefType == "number"){
			prefValue = parseInt(prefValue);
			if(isNaN(prefValue)) { prefValue = prefLastValue; }
		}

		if(prefValue != prefLastValue) {
			tabloc_setting_setPrefValue(prefString, prefValue);
		}
	}
}

function tabloc_setting_setPrefValue(aPrefString, aPrefValue) {
	var defaultValue = tabloc_getDefaultValue(aPrefString);
  var prefBranch = getPrefBranch();

	switch(typeof(defaultValue)){
		case "boolean":
			prefBranch.setBoolPref(aPrefString, aPrefValue);
			break;
		case "number":
			prefBranch.setIntPref(aPrefString, aPrefValue);
			break;
		case "string":
			var supportsString = Components.classes["@mozilla.org/supports-string;1"]
				.createInstance(Components.interfaces.nsISupportsString);
			supportsString.data = aPrefValue;
			prefBranch.setComplexValue(aPrefString,
				Components.interfaces.nsISupportsString, supportsString);
			break;
	}
}

function tabloc_charCode(str){
	return str.charCodeAt(0);
}

function tabloc_setting_makeKeyList(menu){
	var listKey = document.getElementById(menu);
	listKey.removeAllItems();
	listKey.appendItem("(none)", "");
	for(var i=tabloc_charCode("A"); i <= tabloc_charCode("Z"); i++){
		var str = String.fromCharCode(i);
		listKey.appendItem(str, str);
	}
}

function tabloc_setting_makeSkinList(){
	var listSkin = document.getElementById("listSkin");
	var dirlist = tabloc_getPrefValue("skz.tabloc.skindirs").split(";");

	listSkin.removeAllItems();
	for(var i=0; i<dirlist.length; i++){
		var dir = dirlist[i];
		if(dir != ""){
			var path = unescape(dir).split("/");
			var label = dir;
			for(var j=path.length-1; j>=0; j--){
				if(path[j] != ""){
					label = path[j];
					break;
				}
			}
			listSkin.appendItem(label, dir);
		}
	}
}

function tabloc_setting_addSkin(){
	var listSkin = document.getElementById("listSkin");
	var picker = Components.classes["@mozilla.org/filepicker;1"]
		.getService(Components.interfaces.nsIFilePicker);
	picker.init(window, "Skin Folder", 2);
	if (picker.show() != 0){ return; }
	
	var dir = picker.fileURL.spec;
	tabloc_setting_setPrefValue("skz.tabloc.skindirs",
		tabloc_getPrefValue("skz.tabloc.skindirs") + dir + ";");
	tabloc_setting_makeSkinList();
	listSkin.value = dir;
}

function tabloc_setting_removeSkin(){
	var listSkin = document.getElementById("listSkin");
	var dir = listSkin.value;
	var defaultVal = tabloc_getDefaultValue("skz.tabloc.skin");
	var dirlist = tabloc_getPrefValue("skz.tabloc.skindirs");
	dirlist = replaceAll(dirlist, ";" + dir + ";", ";");
	if((dirlist != defaultVal) && (dirlist.indexOf(defaultVal + ";") != 0)){
	  dirlist = defaultVal + ";" + dirlist;
	}
	tabloc_setting_setPrefValue("skz.tabloc.skindirs", dirlist);
	tabloc_setting_makeSkinList();
	listSkin.value = defaultVal;
}
